>From 49c798d880f0504755642efb0a83b0682e72caf4 Mon Sep 17 00:00:00 2001
From: Jakub Hrozek <jhrozek@redhat.com>
Date: Fri, 14 Aug 2009 15:09:57 +0200
Subject: [PATCH 2/3] Decouple synchronous sysdb interface from tools

Instead of working directly with async code in tools, create synchronous
wrappers that could be used by tools and python bindings.

Also resolves many issues with code duplication in tools and thus fixes
ticket #87
---
 server/Makefile.am                 |    6 +-
 server/tools/common/sss_sync_ops.c |  814 ++++++++++++++++++++++++++++++++++++
 server/tools/common/sss_sync_ops.h |   68 +++
 server/tools/common/tools_util.c   |  336 +++++++++++++++
 server/tools/common/tools_util.h   |   81 ++++
 server/tools/sss_groupadd.c        |  107 +-----
 server/tools/sss_groupdel.c        |  115 +-----
 server/tools/sss_groupmod.c        |  267 +-----------
 server/tools/sss_useradd.c         |  262 ++----------
 server/tools/sss_userdel.c         |  118 +-----
 server/tools/sss_usermod.c         |  350 ++--------------
 server/tools/tools_util.c          |  373 -----------------
 server/tools/tools_util.h          |   99 -----
 13 files changed, 1426 insertions(+), 1570 deletions(-)
 create mode 100644 server/tools/common/sss_sync_ops.c
 create mode 100644 server/tools/common/sss_sync_ops.h
 create mode 100644 server/tools/common/tools_util.c
 create mode 100644 server/tools/common/tools_util.h
 delete mode 100644 server/tools/tools_util.c
 delete mode 100644 server/tools/tools_util.h

diff --git a/server/Makefile.am b/server/Makefile.am
index 12ec4b1..0a81ab4 100644
--- a/server/Makefile.am
+++ b/server/Makefile.am
@@ -169,7 +169,8 @@ SSSD_RESPONDER_OBJ = \
     responder/common/responder_packet.c
 
 SSSD_TOOLS_OBJ = \
-    tools/tools_util.c
+    tools/common/sss_sync_ops.c \
+    tools/common/tools_util.c
 
 SSSD_RESOLV_OBJ = \
     resolv/async_resolv.c
@@ -226,7 +227,8 @@ dist_noinst_HEADERS = \
     providers/krb5/krb5_auth.h \
     providers/ldap/sdap.h \
     providers/ldap/sdap_async.h \
-    tools/tools_util.h \
+    tools/common/tools_util.h \
+    tools/common/sss_sync_ops.h \
     krb5_plugin/sssd_krb5_locator_plugin.h \
     resolv/async_resolv.h \
     resolv/ares/ares_parse_srv_reply.h \
diff --git a/server/tools/common/sss_sync_ops.c b/server/tools/common/sss_sync_ops.c
new file mode 100644
index 0000000..e85838a
--- /dev/null
+++ b/server/tools/common/sss_sync_ops.c
@@ -0,0 +1,814 @@
+/*
+ * Authors:
+ *   Jakub Hrozek <jhrozek@redhat.com>
+ *
+ * Copyright (C) 2008  Red Hat
+ * see file 'COPYING' for use and warranty information
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; version 2 only
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ */
+
+#include <tevent.h>
+#include <talloc.h>
+
+#include "util/util.h"
+#include "db/sysdb.h"
+
+#include "tools/common/sss_sync_ops.h"
+
+/* Default settings for user attributes */
+#define CONFDB_DFL_SECTION "config/user_defaults"
+
+#define DFL_SHELL_ATTR     "defaultShell"
+#define DFL_BASEDIR_ATTR   "baseDirectory"
+
+#define DFL_SHELL_VAL      "/bin/bash"
+#define DFL_BASEDIR_VAL    "/home"
+
+#define VAR_CHECK(var, val, attr, msg) do { \
+        if (var != (val)) { \
+            DEBUG(1, (msg" attribute: %s", attr)); \
+            return val; \
+        } \
+} while(0)
+
+typedef void (*sync_callback_fn)(struct tevent_req *);
+typedef struct ldb_dn* (*dn_fn)(struct sysdb_ctx *, void *, const char *, const char *);
+
+struct sync_ops_ctx {
+    struct tevent_context *ev;
+    struct sysdb_ctx *sysdb;
+    struct confdb_ctx *confdb;
+
+    struct sysdb_attrs *attrs;
+    dn_fn member_dn_fn;
+    int cur;
+
+    struct sysdb_handle *handle;
+    int error;
+    bool done;
+
+    struct ops_ctx *data;
+};
+
+/*
+ * common functions
+ */
+int setup_db(TALLOC_CTX *mem_ctx,
+             struct tevent_context *ev,
+             struct confdb_ctx **_confdb,
+             struct sysdb_ctx **_sysdb)
+{
+    struct confdb_ctx *confdb;
+    struct sysdb_ctx *sysdb;
+    char *confdb_path;
+    int ret;
+
+    /* Create the event context */
+    confdb_path = talloc_asprintf(mem_ctx, "%s/%s", DB_PATH, CONFDB_FILE);
+    if (confdb_path == NULL) {
+        return ENOMEM;
+    }
+
+    /* Connect to the conf db */
+    ret = confdb_init(mem_ctx, ev, &confdb, confdb_path);
+    if (ret != EOK) {
+        DEBUG(1, ("Could not initialize connection to the confdb"));
+        talloc_free(confdb_path);
+        return ret;
+    }
+
+    /* open sysdb at default path */
+    ret = sysdb_init(mem_ctx, ev, confdb, NULL, &sysdb);
+    if (ret != EOK) {
+        DEBUG(1, ("Could not initialize connection to the sysdb"));
+        talloc_free(confdb_path);
+        return ret;
+    }
+
+    talloc_free(confdb_path);
+    *_confdb = confdb;
+    *_sysdb = sysdb;
+    return EOK;
+}
+
+static int synchronous_transaction(TALLOC_CTX *mem_ctx,
+                                   sync_callback_fn cbc,
+                                   struct ops_ctx *data)
+{
+    int ret;
+    struct tevent_req *req;
+    struct sync_ops_ctx *octx = NULL;
+
+    octx = talloc_zero(mem_ctx, struct sync_ops_ctx);
+    if (octx == NULL) {
+        DEBUG(1, ("Could not create sync_ops context"));
+        return ENOMEM;
+    }
+
+    /* A private event context for the duration of the sync transaction */
+    octx->ev = tevent_context_init(mem_ctx);
+    if (octx->ev == NULL) {
+        DEBUG(1, ("Could not create event context"));
+        ret = EIO;
+        goto done;
+    }
+
+    ret = setup_db(octx, octx->ev, &octx->confdb, &octx->sysdb);
+    if (ret != EOK) {
+        DEBUG(1, ("Could not set up database\n"));
+        goto done;
+    }
+    octx->data = data;
+
+    req = sysdb_transaction_send(octx, octx->ev, octx->sysdb);
+    if (!req) {
+        DEBUG(1, ("Could not start transaction"));
+        ret = ENOMEM;
+        goto done;
+    }
+    tevent_req_set_callback(req, cbc, octx);
+
+    while (!octx->done) {
+        tevent_loop_once(octx->ev);
+    }
+    ret = octx->error;
+
+done:
+    talloc_free(octx);
+    return ret;
+}
+
+static void req_done(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req, struct sync_ops_ctx);
+
+    octx->error = sysdb_transaction_commit_recv(req);
+    octx->done = true;
+}
+
+static void transaction_done(struct sync_ops_ctx *octx, int error)
+{
+    struct tevent_req *req;
+
+    if (error != EOK) {
+        goto fail;
+    }
+
+    req = sysdb_transaction_commit_send(octx, octx->ev, octx->handle);
+    if (!req) {
+        error = ENOMEM;
+        goto fail;
+    }
+    tevent_req_set_callback(req, req_done, octx);
+
+    return;
+
+fail:
+    /* free transaction */
+    talloc_zfree(octx->handle);
+
+    octx->error = error;
+    octx->done = true;
+}
+
+/*
+ * Generic add member to group
+ */
+static void add_to_groups_done(struct tevent_req *subreq);
+
+static void add_to_groups(struct sync_ops_ctx *octx)
+{
+    struct ldb_dn *parent_dn;
+    struct ldb_dn *member_dn;
+    struct tevent_req *subreq;
+
+    member_dn = octx->member_dn_fn(octx->sysdb, octx,
+                                   octx->data->domain->name,
+                                   octx->data->name);
+    if (!member_dn) {
+        return transaction_done(octx, ENOMEM);
+    }
+
+    parent_dn = sysdb_group_dn(octx->sysdb, octx,
+                               octx->data->domain->name,
+                               octx->data->addgroups[octx->cur]);
+    if (!parent_dn) {
+        return transaction_done(octx, ENOMEM);
+    }
+
+    subreq = sysdb_mod_group_member_send(octx,
+                                         octx->ev,
+                                         octx->handle,
+                                         member_dn,
+                                         parent_dn,
+                                         LDB_FLAG_MOD_ADD);
+    if (!subreq) {
+        return transaction_done(octx, ENOMEM);
+    }
+    tevent_req_set_callback(subreq, add_to_groups_done, octx);
+}
+
+static void add_to_groups_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_mod_group_member_recv(subreq);
+    talloc_zfree(subreq);
+    if (ret) {
+        return transaction_done(octx, ret);
+    }
+
+    /* go on to next group */
+    octx->cur++;
+
+    /* check if we added all of them */
+    if (octx->data->addgroups[octx->cur] == NULL) {
+        return transaction_done(octx, EOK);
+    }
+
+    return add_to_groups(octx);
+}
+
+/*
+ * Generic remove member from group
+ */
+static void remove_from_groups_done(struct tevent_req *req);
+
+static void remove_from_groups(struct sync_ops_ctx *octx)
+{
+    struct ldb_dn *parent_dn;
+    struct ldb_dn *member_dn;
+    struct tevent_req *req;
+
+    member_dn = octx->member_dn_fn(octx->sysdb, octx,
+                                   octx->data->domain->name, octx->data->name);
+    if (!member_dn) {
+        return transaction_done(octx, ENOMEM);
+    }
+
+    parent_dn = sysdb_group_dn(octx->sysdb, octx,
+                               octx->data->domain->name,
+                               octx->data->rmgroups[octx->cur]);
+    if (!parent_dn) {
+        return transaction_done(octx, ENOMEM);
+    }
+
+    req = sysdb_mod_group_member_send(octx,
+                                      octx->ev,
+                                      octx->handle,
+                                      member_dn,
+                                      parent_dn,
+                                      LDB_FLAG_MOD_DELETE);
+    if (!req) {
+        return transaction_done(octx, ENOMEM);
+    }
+    tevent_req_set_callback(req, remove_from_groups_done, octx);
+}
+
+static void remove_from_groups_done(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_mod_group_member_recv(req);
+    if (ret) {
+        return transaction_done(octx, ret);
+    }
+    talloc_zfree(req);
+
+    /* go on to next group */
+    octx->cur++;
+
+    /* check if we removed all of them */
+    if (octx->data->rmgroups[octx->cur] == NULL) {
+        octx->cur = 0;
+        if (octx->data->addgroups != NULL) {
+            return add_to_groups(octx);
+        }
+        return transaction_done(octx, EOK);
+    }
+
+    return remove_from_groups(octx);
+}
+
+/*
+ * Add a user
+ */
+static void add_user_done(struct tevent_req *subreq);
+
+void add_user(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req,
+                                                         struct sync_ops_ctx);
+    struct tevent_req *subreq;
+    int ret;
+
+    octx->member_dn_fn = sysdb_user_dn;
+
+    ret = sysdb_transaction_recv(req, octx, &octx->handle);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    subreq = sysdb_add_user_send(octx, octx->ev, octx->handle,
+                                 octx->data->domain, octx->data->name,
+                                 octx->data->uid, octx->data->gid,
+                                 octx->data->gecos, octx->data->home,
+                                 octx->data->shell, NULL);
+    if (!subreq) {
+        transaction_done(octx, ENOMEM);
+    }
+    tevent_req_set_callback(subreq, add_user_done, octx);
+}
+
+static void add_user_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_add_user_recv(subreq);
+    talloc_zfree(subreq);
+    if (ret) {
+        return transaction_done(octx, ret);
+    }
+
+    if (octx->data->addgroups) {
+        return add_to_groups(octx);
+    }
+
+    return transaction_done(octx, ret);
+}
+
+/*
+ * Remove a user
+ */
+static void user_del_done(struct tevent_req *subreq);
+
+static void user_del(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req,
+                                                         struct sync_ops_ctx);
+    struct tevent_req *subreq;
+    struct ldb_dn *user_dn;
+    int ret;
+
+    ret = sysdb_transaction_recv(req, octx, &octx->handle);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    user_dn = sysdb_user_dn(octx->sysdb, octx,
+                            octx->data->domain->name, octx->data->name);
+    if (!user_dn) {
+        DEBUG(1, ("Could not construct a user DN\n"));
+        return transaction_done(octx, ENOMEM);
+    }
+
+    subreq = sysdb_delete_entry_send(octx, octx->ev, octx->handle, user_dn, false);
+    if (!subreq)
+        return transaction_done(octx, ENOMEM);
+
+    tevent_req_set_callback(subreq, user_del_done, octx);
+}
+
+static void user_del_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_delete_entry_recv(subreq);
+
+    return transaction_done(octx, ret);
+}
+
+/*
+ * Modify a user
+ */
+static int usermod_build_attrs(TALLOC_CTX *mem_ctx,
+                               const char *gecos,
+                               const char *home,
+                               const char *shell,
+                               uid_t uid,
+                               gid_t gid,
+                               int lock,
+                               struct sysdb_attrs **_attrs)
+{
+    int ret;
+    struct sysdb_attrs *attrs;
+
+    attrs = sysdb_new_attrs(mem_ctx);
+    if (attrs == NULL) {
+        return ENOMEM;
+    }
+
+    if(shell) {
+        ret = sysdb_attrs_add_string(attrs,
+                                     SYSDB_SHELL,
+                                     shell);
+        VAR_CHECK(ret, EOK, SYSDB_SHELL,
+                  "Could not add attribute to changeset\n");
+    }
+
+    if(home) {
+        ret = sysdb_attrs_add_string(attrs,
+                                     SYSDB_HOMEDIR,
+                                     home);
+        VAR_CHECK(ret, EOK, SYSDB_HOMEDIR,
+                  "Could not add attribute to changeset\n");
+    }
+
+    if(gecos) {
+        ret = sysdb_attrs_add_string(attrs,
+                                     SYSDB_GECOS,
+                                     gecos);
+        VAR_CHECK(ret, EOK, SYSDB_GECOS,
+                  "Could not add attribute to changeset\n");
+    }
+
+    if(uid) {
+        ret = sysdb_attrs_add_long(attrs,
+                                   SYSDB_UIDNUM,
+                                   uid);
+        VAR_CHECK(ret, EOK, SYSDB_UIDNUM,
+                  "Could not add attribute to changeset\n");
+    }
+
+    if(gid) {
+        ret = sysdb_attrs_add_long(attrs,
+                                   SYSDB_GIDNUM,
+                                   gid);
+        VAR_CHECK(ret, EOK, SYSDB_GIDNUM,
+                  "Could not add attribute to changeset\n");
+    }
+
+    if(lock == DO_LOCK) {
+        ret = sysdb_attrs_add_string(attrs,
+                                     SYSDB_DISABLED,
+                                     "true");
+        VAR_CHECK(ret, EOK, SYSDB_DISABLED,
+                  "Could not add attribute to changeset\n");
+    }
+
+    if(lock == DO_UNLOCK) {
+        /* PAM code checks for 'false' value in SYSDB_DISABLED attribute */
+        ret = sysdb_attrs_add_string(attrs,
+                                     SYSDB_DISABLED,
+                                     "false");
+        VAR_CHECK(ret, EOK, SYSDB_DISABLED,
+                  "Could not add attribute to changeset\n");
+    }
+
+    *_attrs = attrs;
+    return EOK;
+}
+
+static void mod_user_attr_done(struct tevent_req *req);
+static void mod_user_cont(struct sync_ops_ctx *octx);
+
+static void mod_user(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req,
+                                                         struct sync_ops_ctx);
+    struct tevent_req *subreq;
+    int ret;
+
+    octx->member_dn_fn = sysdb_user_dn;
+
+    ret = sysdb_transaction_recv(req, octx, &octx->handle);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    ret = usermod_build_attrs(octx,
+                              octx->data->gecos,
+                              octx->data->home,
+                              octx->data->shell,
+                              octx->data->uid,
+                              octx->data->gid,
+                              octx->data->lock,
+                              &octx->attrs);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    if (octx->attrs->num != 0) {
+        subreq = sysdb_set_user_attr_send(octx, octx->ev, octx->handle,
+                                          octx->data->domain, octx->data->name,
+                                          octx->attrs, SYSDB_MOD_REP);
+        if (!subreq) {
+            return transaction_done(octx, ENOMEM);
+        }
+        tevent_req_set_callback(subreq, mod_user_attr_done, octx);
+        return;
+    }
+
+    return mod_user_cont(octx);
+}
+
+static void mod_user_attr_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_set_user_attr_recv(subreq);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    mod_user_cont(octx);
+}
+
+static void mod_user_cont(struct sync_ops_ctx *octx)
+{
+    if (octx->data->rmgroups != NULL) {
+        return remove_from_groups(octx);
+    }
+
+    if (octx->data->addgroups != NULL) {
+        return add_to_groups(octx);
+    }
+
+    return transaction_done(octx, EOK);
+}
+
+/*
+ * Add a group
+ */
+static void add_group_done(struct tevent_req *subreq);
+
+static void add_group(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req,
+                                                         struct sync_ops_ctx);
+    struct tevent_req *subreq;
+    int ret;
+
+    ret = sysdb_transaction_recv(req, octx, &octx->handle);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    subreq = sysdb_add_group_send(octx, octx->ev, octx->handle,
+                                  octx->data->domain, octx->data->name,
+                                  octx->data->gid, NULL);
+    if (!subreq) {
+        transaction_done(octx, ENOMEM);
+    }
+    tevent_req_set_callback(subreq, add_group_done, octx);
+}
+
+static void add_group_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_add_group_recv(subreq);
+    talloc_zfree(subreq);
+
+    return transaction_done(octx, ret);
+}
+
+/*
+ * Delete a group
+ */
+static void group_del_done(struct tevent_req *subreq);
+
+static void group_del(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(req,
+                                                         struct sync_ops_ctx);
+    struct tevent_req *subreq;
+    struct ldb_dn *group_dn;
+    int ret;
+
+    ret = sysdb_transaction_recv(req, octx, &octx->handle);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    group_dn = sysdb_group_dn(octx->sysdb, octx,
+                              octx->data->domain->name, octx->data->name);
+    if (group_dn == NULL) {
+        DEBUG(1, ("Could not construct a group DN\n"));
+        return transaction_done(octx, ENOMEM);
+    }
+
+    subreq = sysdb_delete_entry_send(octx, octx->ev, octx->handle, group_dn, false);
+    if (!subreq)
+        return transaction_done(octx, ENOMEM);
+
+    tevent_req_set_callback(subreq, group_del_done, octx);
+}
+
+static void group_del_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_delete_entry_recv(subreq);
+
+    return transaction_done(octx, ret);
+}
+
+/*
+ * Modify a group
+ */
+static void mod_group_attr_done(struct tevent_req *req);
+static void mod_group_cont(struct sync_ops_ctx *octx);
+
+static void mod_group(struct tevent_req *req)
+{
+    struct sync_ops_ctx *octx;
+    struct tevent_req *subreq;
+    struct sysdb_attrs *attrs;
+    int ret;
+
+    octx = tevent_req_callback_data(req, struct sync_ops_ctx);
+    octx->member_dn_fn = sysdb_group_dn;
+
+    ret = sysdb_transaction_recv(req, octx, &octx->handle);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    if (octx->data->gid != 0) {
+        attrs = sysdb_new_attrs(NULL);
+        if (!attrs) {
+            transaction_done(octx, ENOMEM);
+        }
+        ret = sysdb_attrs_add_uint32(attrs, SYSDB_GIDNUM, octx->data->gid);
+        if (ret) {
+            transaction_done(octx, ret);
+        }
+
+        subreq = sysdb_set_group_attr_send(octx, octx->ev, octx->handle,
+                                           octx->data->domain, octx->data->name,
+                                           attrs, SYSDB_MOD_REP);
+        if (!subreq) {
+            return transaction_done(octx, ENOMEM);
+        }
+        tevent_req_set_callback(subreq, mod_group_attr_done, octx);
+        return;
+    }
+
+    return mod_group_cont(octx);
+}
+
+static void mod_group_attr_done(struct tevent_req *subreq)
+{
+    struct sync_ops_ctx *octx = tevent_req_callback_data(subreq,
+                                                         struct sync_ops_ctx);
+    int ret;
+
+    ret = sysdb_set_group_attr_recv(subreq);
+    talloc_zfree(subreq);
+    if (ret != EOK) {
+        return transaction_done(octx, ret);
+    }
+
+    mod_group_cont(octx);
+}
+
+static void mod_group_cont(struct sync_ops_ctx *octx)
+{
+    if (octx->data->rmgroups != NULL) {
+        return remove_from_groups(octx);
+    }
+
+    if (octx->data->addgroups != NULL) {
+        return add_to_groups(octx);
+    }
+
+    return transaction_done(octx, EOK);
+}
+
+/*
+ * Default values for add operations
+ */
+int useradd_defaults(TALLOC_CTX *mem_ctx,
+                     struct confdb_ctx *confdb,
+                     struct ops_ctx *data,
+                     const char *gecos,
+                     const char *homedir,
+                     const char *shell)
+{
+    int ret;
+    char *basedir = NULL;
+    char *dfl_shell = NULL;
+
+    data->gecos = talloc_strdup(mem_ctx, gecos ? gecos : data->name);
+    if (!data->gecos) {
+        return ENOMEM;
+    }
+
+    if (homedir) {
+        data->home = talloc_strdup(data, homedir);
+    } else {
+        ret = confdb_get_string(confdb, mem_ctx,
+                                CONFDB_DFL_SECTION, DFL_BASEDIR_ATTR,
+                                DFL_BASEDIR_VAL, &basedir);
+        if (ret != EOK) {
+            goto done;
+        }
+        data->home = talloc_asprintf(mem_ctx, "%s/%s", basedir, data->name);
+        if (!data->home) {
+            ret = ENOMEM;
+            goto done;
+        }
+    }
+    if (!data->home) {
+        ret = ENOMEM;
+        goto done;
+    }
+
+    if (!shell) {
+        ret = confdb_get_string(confdb, mem_ctx,
+                                CONFDB_DFL_SECTION, DFL_SHELL_ATTR,
+                                DFL_SHELL_VAL, &dfl_shell);
+        if (ret != EOK) {
+            goto done;
+        }
+        shell = dfl_shell;
+    }
+    data->shell = talloc_strdup(mem_ctx, shell);
+    if (!data->shell) {
+        ret = ENOMEM;
+        goto done;
+    }
+
+    ret = EOK;
+done:
+    talloc_free(dfl_shell);
+    talloc_free(basedir);
+    return ret;
+}
+
+/*
+ * Public interface for adding users
+ */
+int useradd(TALLOC_CTX *mem_ctx, struct ops_ctx *data)
+{
+    return synchronous_transaction(mem_ctx, add_user, data);
+}
+
+/*
+ * Public interface for deleting users
+ */
+int userdel(TALLOC_CTX *mem_ctx, struct ops_ctx *data)
+{
+    return synchronous_transaction(mem_ctx, user_del, data);
+}
+
+/*
+ * Public interface for modifying users
+ */
+int usermod(TALLOC_CTX *mem_ctx, struct ops_ctx *data)
+{
+    return synchronous_transaction(mem_ctx, mod_user, data);
+}
+
+/*
+ * Public interface for adding groups
+ */
+int groupadd(TALLOC_CTX *mem_ctx, struct ops_ctx *data)
+{
+    return synchronous_transaction(mem_ctx, add_group, data);
+}
+
+/*
+ * Public interface for deleting groups
+ */
+int groupdel(TALLOC_CTX *mem_ctx, struct ops_ctx *data)
+{
+    return synchronous_transaction(mem_ctx, group_del, data);
+}
+
+/*
+ * Public interface for modifying groups
+ */
+int groupmod(TALLOC_CTX *mem_ctx, struct ops_ctx *data)
+{
+    return synchronous_transaction(mem_ctx, mod_group, data);
+}
+
diff --git a/server/tools/common/sss_sync_ops.h b/server/tools/common/sss_sync_ops.h
new file mode 100644
index 0000000..4107986
--- /dev/null
+++ b/server/tools/common/sss_sync_ops.h
@@ -0,0 +1,68 @@
+/*
+ * Authors:
+ *   Jakub Hrozek <jhrozek@redhat.com>
+ *
+ * Copyright (C) 2009  Red Hat
+ * see file 'COPYING' for use and warranty information
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; version 2 only
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+ */
+
+#ifndef __SSS_OPS_H__
+#define __SSS_OPS_H__
+
+#include <stdbool.h>
+
+#define DO_LOCK     1
+#define DO_UNLOCK   2
+
+struct ops_ctx {
+    struct sss_domain_info *domain;
+
+    char *name;
+    uid_t uid;
+    gid_t gid;
+    char *gecos;
+    char *home;
+    char *shell;
+    int   lock;
+
+    char **addgroups;
+    char **rmgroups;
+};
+
+/* connect to confdb and sysdb using ev event context */
+int setup_db(TALLOC_CTX *mem_ctx,
+             struct tevent_context *ev,
+             struct confdb_ctx **_confdb,
+             struct sysdb_ctx **_sysdb);
+
+/* default values for add operations */
+int useradd_defaults(TALLOC_CTX *mem_ctx,
+                     struct confdb_ctx *confdb,
+                     struct ops_ctx *data,
+                     const char *gecos,
+                     const char *homedir,
+                     const char *shell);
+
+/* synchronous operations */
+int useradd(TALLOC_CTX *mem_ctx, struct ops_ctx *data);
+int userdel(TALLOC_CTX *mem_ctx, struct ops_ctx *data);
+int usermod(TALLOC_CTX *mem_ctx, struct ops_ctx *data);
+
+int groupadd(TALLOC_CTX *mem_ctx, struct ops_ctx *data);
+int groupdel(TALLOC_CTX *mem_ctx, struct ops_ctx *data);
+int groupmod(TALLOC_CTX *mem_ctx, struct ops_ctx *data);
+#endif /* __SSS_OPS_H__ */
+
